Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/policy/AbstractManagementSystem.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/policy/AbstractManagementSystem.java	(revision 1377)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/policy/AbstractManagementSystem.java	(revision 1396)
@@ -23,7 +23,7 @@
 import schedframe.scheduling.plan.AllocationInterface;
 import schedframe.scheduling.plan.SchedulingPlanInterface;
+import schedframe.scheduling.plugin.ModuleList;
 import schedframe.scheduling.plugin.SchedulingPlugin;
 import schedframe.scheduling.plugin.estimation.ExecutionTimeEstimationPlugin;
-import schedframe.scheduling.plugin.grid.ModuleList;
 import schedframe.scheduling.manager.resources.ResourceAllocation;
 import schedframe.scheduling.queue.TaskQueue;
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/policy/local/LocalManagementSystem.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/policy/local/LocalManagementSystem.java	(revision 1392)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/policy/local/LocalManagementSystem.java	(revision 1396)
@@ -4,8 +4,6 @@
 import java.util.HashMap;
 import java.util.Iterator;
-import java.util.LinkedList;
 import java.util.List;
 import java.util.Map;
-import java.util.Set;
 
 import org.apache.commons.logging.Log;
@@ -33,5 +31,5 @@
 import schedframe.resources.units.StandardResourceUnitName;
 import schedframe.scheduling.ExecutionHistoryItem;
-import schedframe.scheduling.ResourceHistoryItem;
+import schedframe.scheduling.ResourceItem;
 import schedframe.scheduling.Scheduler;
 import schedframe.scheduling.TaskList;
@@ -44,7 +42,7 @@
 import schedframe.scheduling.plan.ScheduledTaskInterface;
 import schedframe.scheduling.plan.SchedulingPlanInterface;
+import schedframe.scheduling.plugin.ModuleListImpl;
 import schedframe.scheduling.plugin.SchedulingPlugin;
 import schedframe.scheduling.plugin.estimation.ExecutionTimeEstimationPlugin;
-import schedframe.scheduling.plugin.grid.ModuleListImpl;
 import schedframe.scheduling.policy.AbstractManagementSystem;
 import schedframe.scheduling.queue.TaskQueueList;
@@ -56,5 +54,5 @@
 import schedframe.scheduling.tasks.WorkloadUnit;
 import simulator.DCWormsConstants;
-import simulator.stats.GSSAccumulator;
+import simulator.stats.DCwormsAccumulator;
 import simulator.utils.DoubleMath;
 import dcworms.schedframe.scheduling.ExecTask;
@@ -382,5 +380,5 @@
 
 		saveExecutionHistory(exec, exec.getCompletionPercentage(), phaseDuration);
-		if(exec.getResourceConsumptionProfile().isLast()){
+		if(exec.getExecutionProfile().isLast()){
 			scheduler.sendInternal(phaseDuration, DCWormsTags.TASK_EXECUTION_FINISHED, execTask);;
 		} else {
@@ -451,5 +449,5 @@
 			ExecTask task = iter.next();
 			Executable exec = (Executable)task;
-			ExecutionHistoryItem execHistItem = exec.getExecHistory().getLast();
+			ExecutionHistoryItem execHistItem = exec.getExecutionHistory().getLast();
 			//System.out.println("--- upadteProgressX: " + Sim_system.sim_clock() );
 			//System.out.println("taskId: " + exec.getId() + "; completion percentage: " + exec.getCompletionPercentage() + "; timespan: " + timeSpan + "; estimatedDuration: " +  execHistItem.getCompletionPercentage());
@@ -496,5 +494,5 @@
 					execTask, choosenResources, exec.getCompletionPercentage())).intValue();
 
-			ExecutionHistoryItem execHistItem = exec.getExecHistory().getLast();
+			ExecutionHistoryItem execHistItem = exec.getExecutionHistory().getLast();
 			double lastTimeStamp = execHistItem.getTimeStamp().getMillis()/1000;
 			if(DoubleMath.subtract((lastTimeStamp + execHistItem.getEstimatedDuration()), (new DateTime().getMillis()/1000 + phaseDuration)) == 0.0){
@@ -508,5 +506,5 @@
 			saveExecutionHistory(exec, exec.getCompletionPercentage(), phaseDuration);
 			
-			if(exec.getResourceConsumptionProfile().isLast()){
+			if(exec.getExecutionProfile().isLast()){
 				ExecTaskFilter filter = new ExecTaskFilter(exec.getUniqueId(), DCWormsTags.TASK_EXECUTION_FINISHED);
 				scheduler.sim_cancel(filter, null);
@@ -542,5 +540,5 @@
 			saveExecutionHistory(exec, exec.getCompletionPercentage(), phaseDuration);
 			
-			if(exec.getResourceConsumptionProfile().isLast()){
+			if(exec.getExecutionProfile().isLast()){
 				scheduler.sendInternal(phaseDuration, DCWormsTags.TASK_EXECUTION_FINISHED, execTask);
 			} else {
@@ -555,5 +553,5 @@
 	public double calculateTotalLoad() {
 
-		GSSAccumulator loadAcc = new GSSAccumulator();
+		DCwormsAccumulator loadAcc = new DCwormsAccumulator();
 		try {
 			for(ComputingResource compRes: getResourceManager().getResourcesOfType(StandardResourceType.Node)){
@@ -718,7 +716,6 @@
 		boolean allocationStatus = getAllocationManager().allocateResources(choosenResources, exclusive);
 		if(allocationStatus){
-			ResourceHistoryItem resourceHistoryItem = new ResourceHistoryItem(choosenResources);
+			ResourceItem resourceHistoryItem = new ResourceItem(choosenResources);
 			exec.addAllocatedResources(resourceHistoryItem);
-			saveResourceHistory(exec);
 			return true;
 		}
@@ -726,28 +723,5 @@
 	}
 	
-	private void saveResourceHistory(Executable exec){
-		ProcessingElements pes = (ProcessingElements) exec.getAllocatedResources().getLast().getResourceUnits().get(StandardResourceUnitName.PE);
-		for (ComputingResource resource : pes) {
-
-			LinkedList<ComputingResource> toExamine = new LinkedList<ComputingResource>();
-			toExamine.push(resource);
-
-			while (!toExamine.isEmpty()) {
-				ComputingResource compResource = toExamine.pop();
-				List<ComputingResource> resources = compResource.getChildren();
-				if(resources.isEmpty()){
-					Set<String> visitedResources = exec.getAllocatedResources().getLast().getVisitedResources();
-					if(!visitedResources.contains(compResource.getFullName())){
-						exec.getAllocatedResources().getLast().trackResource(compResource.getFullName());
-					}
-				} else {
-					for (int i = 0; i < resources.size(); i++) {
-						ComputingResource resourceChild = resources.get(i);
-						toExamine.addLast(resourceChild);
-					}
-				}
-			}
-		}
-	}
+
 	
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/GridResourceDiscovery.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/GridResourceDiscovery.java	(revision 493)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/GridResourceDiscovery.java	(revision 1396)
@@ -20,5 +20,5 @@
 import schedframe.resources.units.ResourceUnitName;
 import schedframe.scheduling.manager.resources.ResourceManager;
-import schedframe.scheduling.plugin.grid.ModuleType;
+import schedframe.scheduling.plugin.ModuleType;
 import schedframe.scheduling.plugin.grid.ResourceDiscovery;
 import schedframe.scheduling.tasks.requirements.AbstractResourceRequirements;
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/resources/LocalResourceManager.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/resources/LocalResourceManager.java	(revision 1392)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/resources/LocalResourceManager.java	(revision 1396)
@@ -306,5 +306,5 @@
 			for(ResourceUnitName resUnitName: resources.keySet()){
 				ResourceUnit resUnit = resources.get(resUnitName);
-				if(resUnit.getName().getName().equals(StandardResourceUnitName.PE.getName())){
+				if(resUnit.getName().getLabel().equals(StandardResourceUnitName.PE.getLabel())){
 					ProcessingElements pe = (ProcessingElements)resUnit;
 					for(ComputingResource cr: pe){
Index: DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/tasks/JobRegistryImpl.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/tasks/JobRegistryImpl.java	(revision 1362)
+++ DCWoRMS/branches/coolemall/src/schedframe/scheduling/manager/tasks/JobRegistryImpl.java	(revision 1396)
@@ -53,5 +53,5 @@
 			for (ExecTask task: executables) {
 				if (task.getStatus() == status) {
-					Set<String> visitedResource = task.getAllocatedResources().getLast().getVisitedResources();
+					Set<String> visitedResource = task.getAllocatedResources().getLast().getResourceNames();
 					for(String res: visitedResource){
 						if(res.contains(context)){
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/ResourceHistoryItem.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/ResourceHistoryItem.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/ResourceHistoryItem.java	(revision 1396)
@@ -0,0 +1,34 @@
+package schedframe.resources;
+
+
+public class ResourceHistoryItem {
+	
+	private long timestamp;	
+	private String resourceName;
+	private String action;
+	private String paramter;
+	
+	public ResourceHistoryItem(long timestamp, String resourceName, String action, String paramter) {
+		super();
+		this.timestamp = timestamp;
+		this.resourceName = resourceName;
+		this.action = action;
+		this.paramter = paramter;
+	}
+	
+	public long getTimestamp() {
+		return timestamp;
+	}
+	
+	public String getResourceName() {
+		return resourceName;
+	}
+	
+	public String getAction() {
+		return action;
+	}
+	
+	public String getParamter() {
+		return paramter;
+	}
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/ResourceTypeFactory.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/ResourceTypeFactory.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/ResourceTypeFactory.java	(revision 1396)
@@ -60,5 +60,5 @@
 			return StandardResourceType.LS;
 		
-		return new UserResourceType(typeName);
+		return new CustomResourceType(typeName);
 	}
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/devices/coolemall/FanAirflowInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/devices/coolemall/FanAirflowInterface.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/devices/coolemall/FanAirflowInterface.java	(revision 1396)
@@ -0,0 +1,22 @@
+package schedframe.resources.devices.coolemall;
+
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowProfile;
+import schedframe.resources.computing.profiles.energy.airthroughput.CustomAirflowStateName;
+import schedframe.resources.devices.PhysicalResource;
+import schedframe.resources.devices.DeviceAirflowInterface;
+
+public class FanAirflowInterface extends DeviceAirflowInterface {
+
+	public FanAirflowInterface(PhysicalResource resource, AirflowProfile airflowProfile) {
+		super(resource, airflowProfile);
+		this.currentAirflowState = new CustomAirflowStateName("2");
+	}
+	
+	public boolean turnOn(){
+		return setAirflowState(new CustomAirflowStateName("2"));
+	}
+
+	public boolean turnOff(){
+		return setAirflowState(new CustomAirflowStateName("1"));
+	}
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/devices/Device.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/devices/Device.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/devices/Device.java	(revision 1396)
@@ -25,5 +25,5 @@
 		this.extensionList = new ExtensionListImpl(1);
 		initCharacteristics(devDesc);
-		accept(new EnergyExtension.Builder().resource(this).powerProfile(devDesc.getPowerProfile()).airFlowProfile(devDesc.getAirThroughputProfile()).thermalProfile(devDesc.getThermalProfile()).build());	
+		accept(new EnergyExtension.Builder().resource(this).powerProfile(devDesc.getPowerProfile()).airflowProfile(devDesc.getAirflowProfile()).thermalProfile(devDesc.getThermalProfile()).build());	
 	}
 
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/devices/description/PhysicalResourceDescription.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/devices/description/PhysicalResourceDescription.java	(revision 1317)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/devices/description/PhysicalResourceDescription.java	(revision 1396)
@@ -10,8 +10,9 @@
 import schedframe.resources.computing.description.ResourceDescription;
 import schedframe.resources.computing.location.Location;
-import schedframe.resources.computing.profiles.energy.airthroughput.AirThroughputProfile;
-import schedframe.resources.computing.profiles.energy.airthroughput.AirThroughputState;
-import schedframe.resources.computing.profiles.energy.airthroughput.plugin.AirThroughputEstimationPlugin;
-import schedframe.resources.computing.profiles.energy.airthroughput.plugin.DefaultAirThroughputEstimationPlugin;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowStateNameFactory;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowProfile;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowState;
+import schedframe.resources.computing.profiles.energy.airthroughput.plugin.AirflowEstimationPlugin;
+import schedframe.resources.computing.profiles.energy.airthroughput.plugin.DefaultAirflowEstimationPlugin;
 import schedframe.resources.computing.profiles.energy.power.PState;
 import schedframe.resources.computing.profiles.energy.power.PowerProfile;
@@ -36,5 +37,5 @@
 
 	protected PowerProfile powerProfile;
-	protected AirThroughputProfile airThroughputProfile;
+	protected AirflowProfile airflowProfile;
 	protected ThermalProfile thermalProfile;
 	protected LoadProfile loadProfile;
@@ -58,5 +59,5 @@
 		if (profile != null) {
 			initPowerProfile(profile.getPowerProfile());
-			initAirThroughputProfile(profile.getAirThroughputProfile());
+			initAirflowProfile(profile.getAirThroughputProfile());
 			initThermalProfile(profile.getThermalProfile());
 			initLoadProfile(profile.getLoadProfile());
@@ -151,35 +152,35 @@
 	}
 
-	protected void initAirThroughputProfile(schemas.AirThroughputProfile airThroughputProfile) {
-		if (airThroughputProfile != null) {
-			
-			AirThroughputEstimationPlugin airThroughputEstimationPlugin = null;
-			List<AirThroughputState> airThroughputStates = null;
-			if(airThroughputProfile.getAirThroughputEstimationPlugin() != null){
-				String airThroughputEstimationPluginName = airThroughputProfile.getAirThroughputEstimationPlugin().getName();
-				if(airThroughputEstimationPluginName != null) {
-					airThroughputEstimationPlugin = (AirThroughputEstimationPlugin) InstanceFactory.createInstance(
-							airThroughputEstimationPluginName, AirThroughputEstimationPlugin.class);			
+	protected void initAirflowProfile(schemas.AirThroughputProfile airflowProfile) {
+		if (airflowProfile != null) {
+			
+			AirflowEstimationPlugin airflowEstimationPlugin = null;
+			List<AirflowState> airflowStates = null;
+			if(airflowProfile.getAirThroughputEstimationPlugin() != null){
+				String airflowEstimationPluginName = airflowProfile.getAirThroughputEstimationPlugin().getName();
+				if(airflowEstimationPluginName != null) {
+					airflowEstimationPlugin = (AirflowEstimationPlugin) InstanceFactory.createInstance(
+							airflowEstimationPluginName, AirflowEstimationPlugin.class);			
 				} else {
-					airThroughputEstimationPlugin = new DefaultAirThroughputEstimationPlugin();
-				}
-				Parameters params = extractParameters(airThroughputProfile.getAirThroughputEstimationPlugin().getParameter());
-				airThroughputEstimationPlugin.init(params);
-			}
-			if(airThroughputProfile.getAirThroughputStates() != null){
-				airThroughputStates = new ArrayList<AirThroughputState>();
-				int airThrouhputStateCount = airThroughputProfile.getAirThroughputStates().getAirThroughputStateCount();
-				for (int i = 0; i < airThrouhputStateCount; i++) {
-					schemas.AirThroughputState ats = airThroughputProfile.getAirThroughputStates().getAirThroughputState(i);
-					AirThroughputState airThroughputState = new AirThroughputState(ats.getName(), ats.getValue()
+					airflowEstimationPlugin = new DefaultAirflowEstimationPlugin();
+				}
+				Parameters params = extractParameters(airflowProfile.getAirThroughputEstimationPlugin().getParameter());
+				airflowEstimationPlugin.init(params);
+			}
+			if(airflowProfile.getAirThroughputStates() != null){
+				airflowStates = new ArrayList<AirflowState>();
+				int airflowStateCount = airflowProfile.getAirThroughputStates().getAirThroughputStateCount();
+				for (int i = 0; i < airflowStateCount; i++) {
+					schemas.AirThroughputState ats = airflowProfile.getAirThroughputStates().getAirThroughputState(i);
+					AirflowState airflowState = new AirflowState(AirflowStateNameFactory.createAirflowStateName(ats.getName()), ats.getValue()
 							.getContent(), ats.getPowerUsage().getContent());
 					Parameters params = extractParameters(ats.getParameter());
-					airThroughputState.init(params);
-					airThroughputStates.add(airThroughputState);
-				}
-			}
-			this.airThroughputProfile = new AirThroughputProfile(airThroughputEstimationPlugin, airThroughputStates);
-			Parameters params = extractParameters(airThroughputProfile.getParameter());
-			this.airThroughputProfile.init(params);
+					airflowState.init(params);
+					airflowStates.add(airflowState);
+				}
+			}
+			this.airflowProfile = new AirflowProfile(airflowEstimationPlugin, airflowStates);
+			Parameters params = extractParameters(airflowProfile.getParameter());
+			this.airflowProfile.init(params);
 		}
 	}
@@ -281,6 +282,6 @@
 	}
 
-	public AirThroughputProfile getAirThroughputProfile() {
-		return airThroughputProfile;
+	public AirflowProfile getAirflowProfile() {
+		return airflowProfile;
 	}
 
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/devices/DeviceAirflowInterface.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/devices/DeviceAirflowInterface.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/devices/DeviceAirflowInterface.java	(revision 1396)
@@ -0,0 +1,111 @@
+package schedframe.resources.devices;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import org.joda.time.DateTimeUtils;
+
+import schedframe.Parameters;
+import schedframe.resources.computing.profiles.energy.EnergyEvent;
+import schedframe.resources.computing.profiles.energy.EnergyEventType;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowValue;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowProfile;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowState;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirflowStateName;
+import schedframe.resources.computing.profiles.energy.airthroughput.StandardAirflowStateName;
+import schedframe.resources.computing.profiles.energy.airthroughput.ui.AirflowInterface;
+
+public class DeviceAirflowInterface implements AirflowInterface{
+
+	protected AirflowStateName currentAirflowState;
+	protected AirflowProfile airflowProfile;
+	protected PhysicalResource resource;
+	
+	public DeviceAirflowInterface(PhysicalResource resource, AirflowProfile airflowProfile){
+		this.resource = resource;
+		this.airflowProfile = airflowProfile;
+		this.currentAirflowState = StandardAirflowStateName.ON;
+	}
+	
+	public AirflowStateName getAirflowState() {
+		return currentAirflowState;
+	}
+
+	public boolean setAirflowState(AirflowStateName state) {
+		if(supportAirflowState(state)){
+			currentAirflowState = state;
+			
+			//TO DO - notifications should be called for all resources starting form the lowest layer
+			resource.handleEvent(new EnergyEvent(EnergyEventType.AIRFLOW_STATE_CHANGED, resource.getFullName()));
+			resource.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, resource.getFullName()));
+			return true;
+		}
+		return false;
+	}
+
+	public boolean supportAirflowState(AirflowStateName state) {
+		for(AirflowState airflowState: airflowProfile.getAirflowStates()){
+			if(airflowState.getName().getLabel().equals(state.getLabel())){
+				return true;
+			}
+		}
+		return false;
+	}
+
+	public List<AirflowState> getSupportedAirflowStates(){
+		List<AirflowState> airflowStates = new ArrayList<AirflowState>();
+		for(AirflowState airFlowState: airflowProfile.getAirflowStates()){
+			airflowStates.add(airFlowState);
+		}
+		return airflowStates;
+	}
+
+	public double getAirflow(AirflowStateName state) throws NoSuchFieldException {
+		double airflow = 0;
+		if(supportAirflowState(state)){
+			for(AirflowState airflowState: airflowProfile.getAirflowStates()){
+				if(airflowState.getName().getLabel().equals(state.getLabel())){
+					airflow = airflowState.getValue();
+					break;
+				}
+			}
+		}
+		return airflow;
+	}
+
+	public double getPowerConsumption(AirflowStateName state) throws NoSuchFieldException {
+		double powerConsumption = 0;
+		if(supportAirflowState(state)){
+			for(AirflowState airflowState: airflowProfile.getAirflowStates()){
+				if(airflowState.getName().getLabel().equals(state.getLabel())){
+					powerConsumption = airflowState.getPowerUsage();
+					break;
+				}
+			}
+		}
+		return powerConsumption;
+	}
+	
+	public AirflowValue getRecentAirflow() {
+		AirflowValue airflow = null;
+		int lastIdx = getAirflowHistory().size() - 1;
+		if(lastIdx >= 0)
+			airflow = getAirflowHistory().get(lastIdx);
+		else {	
+			try {
+				airflow = new AirflowValue(DateTimeUtils.currentTimeMillis(), getAirflow(currentAirflowState));
+			} catch (NoSuchFieldException e) {
+			}
+		}
+		return airflow;
+	}
+	
+	public List<AirflowValue> getAirflowHistory(){
+		return airflowProfile.getAirflowHistory();
+	}
+	
+	public Parameters getParameters() {
+		return airflowProfile.getParameters();
+	}
+
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/devices/PhysicalResource.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/devices/PhysicalResource.java	(revision 1287)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/devices/PhysicalResource.java	(revision 1396)
@@ -12,5 +12,5 @@
 import schedframe.resources.computing.extensions.ExtensionType;
 import schedframe.resources.computing.profiles.energy.EnergyExtension;
-import schedframe.resources.computing.profiles.energy.airthroughput.ui.AirThroughputInterface;
+import schedframe.resources.computing.profiles.energy.airthroughput.ui.AirflowInterface;
 import schedframe.resources.computing.profiles.energy.power.ui.PowerInterface;
 import schedframe.resources.computing.profiles.energy.thermal.ui.ThermalInterface;
@@ -70,9 +70,9 @@
 	}
 	
-	public AirThroughputInterface getAirThroughputInterface(){
+	public AirflowInterface getAirflowInterface(){
 		Extension extension = getExtension(ExtensionType.ENERGY_EXTENSION);
 		if(extension != null){
 			EnergyExtension ee = (EnergyExtension)extension;
-			return ee.getAirThroughputInterface();
+			return ee.getAirflowInterface();
 		}
 		return null;
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/units/ResourceUnitName.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/units/ResourceUnitName.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/units/ResourceUnitName.java	(revision 1396)
@@ -3,5 +3,5 @@
 public interface ResourceUnitName {
 	
-	public String getName();
+	public String getLabel();
 
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/units/StandardResourceUnitName.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/units/StandardResourceUnitName.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/units/StandardResourceUnitName.java	(revision 1396)
@@ -46,5 +46,5 @@
     }
 
-    public String getName(){
+    public String getLabel(){
     	return this.name;
     }
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/units/ResourceUnitFactory.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/units/ResourceUnitFactory.java	(revision 1384)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/units/ResourceUnitFactory.java	(revision 1396)
@@ -18,19 +18,19 @@
 	
 	public static ResourceUnit createUnit(String unitName, String resId, int totalAmount, int usedAmount){
-		if(unitName.equalsIgnoreCase(StandardResourceUnitName.CPU.getName()))
+		if(unitName.equalsIgnoreCase(StandardResourceUnitName.CPU.getLabel()))
 			return new PEUnit(resId, totalAmount, usedAmount);
-		if(unitName.equalsIgnoreCase(StandardResourceUnitName.PE.getName()))
+		if(unitName.equalsIgnoreCase(StandardResourceUnitName.PE.getLabel()))
 			return new PEUnit(resId, totalAmount, usedAmount);
-		else if(unitName.equalsIgnoreCase(StandardResourceUnitName.MEMORY.getName()))
+		else if(unitName.equalsIgnoreCase(StandardResourceUnitName.MEMORY.getLabel()))
 			 return new Memory(resId, totalAmount, usedAmount);
-		else if(unitName.equalsIgnoreCase(StandardResourceUnitName.STORAGE.getName()))
+		else if(unitName.equalsIgnoreCase(StandardResourceUnitName.STORAGE.getLabel()))
 			 return new Storage(resId, totalAmount, usedAmount);
-		else if(unitName.equalsIgnoreCase(StandardResourceUnitName.GPU.getName()))
+		else if(unitName.equalsIgnoreCase(StandardResourceUnitName.GPU.getLabel()))
 			 return new GPU(resId, totalAmount, usedAmount);
-		else if (unitName.equalsIgnoreCase(StandardResourceUnitName.CPUSPEED.getName()))
+		else if (unitName.equalsIgnoreCase(StandardResourceUnitName.CPUSPEED.getLabel()))
 			return new CpuSpeed(resId, totalAmount, usedAmount); 
-		else if (unitName.equalsIgnoreCase(StandardResourceUnitName.COST.getName()))
+		else if (unitName.equalsIgnoreCase(StandardResourceUnitName.COST.getLabel()))
 			return new Cost(resId, totalAmount);
-		else if (unitName.equalsIgnoreCase(StandardResourceUnitName.APPLICATION.getName()))
+		else if (unitName.equalsIgnoreCase(StandardResourceUnitName.APPLICATION.getLabel()))
 			return new Applications(resId); 
 		else
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/units/ResourceUnitNameFactory.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/units/ResourceUnitNameFactory.java	(revision 477)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/units/ResourceUnitNameFactory.java	(revision 1396)
@@ -6,26 +6,26 @@
 	public static ResourceUnitName createResourceUnitName(String unitName){
 
-		if(unitName.equals(StandardResourceUnitName.MEMORY.getName()))
+		if(unitName.equals(StandardResourceUnitName.MEMORY.getLabel()))
 			return StandardResourceUnitName.MEMORY;
 		
-		else if (unitName.equals(StandardResourceUnitName.STORAGE.getName()))
+		else if (unitName.equals(StandardResourceUnitName.STORAGE.getLabel()))
 			return StandardResourceUnitName.STORAGE;
 		
-		else if (unitName.equals(StandardResourceUnitName.PE.getName()))
+		else if (unitName.equals(StandardResourceUnitName.PE.getLabel()))
 			return StandardResourceUnitName.PE;
 		
-		else if (unitName.equals(StandardResourceUnitName.CPUSPEED.getName()))
+		else if (unitName.equals(StandardResourceUnitName.CPUSPEED.getLabel()))
 			return StandardResourceUnitName.CPUSPEED;
 		
-		else if (unitName.equals(StandardResourceUnitName.GPU.getName()))
+		else if (unitName.equals(StandardResourceUnitName.GPU.getLabel()))
 			return StandardResourceUnitName.GPU;
 		
-		else if (unitName.equals(StandardResourceUnitName.APPLICATION.getName()))
+		else if (unitName.equals(StandardResourceUnitName.APPLICATION.getLabel()))
 			return StandardResourceUnitName.APPLICATION;
 		
-		else if (unitName.equals(StandardResourceUnitName.COST.getName()))
+		else if (unitName.equals(StandardResourceUnitName.COST.getLabel()))
 			return StandardResourceUnitName.COST;
 
-		else return new UserResourceUnitName(unitName);
+		else return new CustomResourceUnitName(unitName);
 	}
 }
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/units/CustomResourceUnitName.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/units/CustomResourceUnitName.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/units/CustomResourceUnitName.java	(revision 1396)
@@ -0,0 +1,15 @@
+package schedframe.resources.units;
+
+public class CustomResourceUnitName implements ResourceUnitName {
+
+	protected String name;
+
+	public CustomResourceUnitName(String name) {
+		this.name = name;
+	}
+
+	public String getLabel() {
+		return name;
+	}
+
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/CustomResourceType.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/CustomResourceType.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/CustomResourceType.java	(revision 1396)
@@ -0,0 +1,16 @@
+package schedframe.resources;
+
+
+public class CustomResourceType implements ResourceType {
+
+	protected String name;
+
+	public CustomResourceType(String name) {
+		this.name = name;
+	}
+
+	public String getName() {
+		return name;
+	}
+	
+}
Index: DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/StandardAirflowStateName.java
===================================================================
--- DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/StandardAirflowStateName.java	(revision 1396)
+++ DCWoRMS/branches/coolemall/src/schedframe/resources/computing/profiles/energy/airthroughput/StandardAirflowStateName.java	(revision 1396)
@@ -0,0 +1,12 @@
+package schedframe.resources.computing.profiles.energy.airthroughput;
+
+public enum  StandardAirflowStateName implements AirflowStateName{
+
+	ON,
+	OFF;
+
+	public String getLabel() {
+		return toString();
+	}
+	
+}
